
%global debug_package   %{nil}

%global provider        github
%global provider_tld    com
%global project         prometheus
%global repo            prometheus
# https://github.com/prometheus/prometheus
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     %{provider_prefix}
%global commit          bc6058c81272a8d938c05e75607371284236aadc
%global shortcommit     %(c=%{commit}; echo ${c:0:7})
%global gopathdir       %{_sourcedir}/go
%global upstream_ver    2.2.1
%global rpm_ver         %(v=%{upstream_ver}; echo ${v//-/_})
%global download_prefix %{provider}.%{provider_tld}/openshift/%{repo}

Name:	        golang-%{provider}-%{project}-%{repo}
Version:	%{rpm_ver}
Release:	2.git%{shortcommit}%{?dist}
Summary:	The Prometheus monitoring system and time series database
License:	ASL 2.0 
URL:		https://prometheus.io/
Source0:        https://%{download_prefix}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz
Patch0:         0001-Updates-for-rpm-build.patch
Patch1:         0002-Revert-Validate-json-parse-for-TargetGroup-Unmarshal.patch

# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
# promu-based packages FTBFS on aarch64 (#1487462)
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 %{arm} ppc64le s390x}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires: %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}	
BuildRequires: prometheus-promu

%description
%{summary}

%package -n %{repo}
Summary:        %{summary}
Provides:       prometheus = %{version}-%{release}

%description -n %{repo}
%{summary}

%prep
%setup -q -n %{repo}-%{commit}
%patch0 -p1
%patch1 -p1

%build
# Go expects a full path to the sources which is not included in the source
# tarball so create a link with the expected path
mkdir -p %{gopathdir}/src/%{provider}.%{provider_tld}/%{project}
ln -s `pwd` %{gopathdir}/src/%{import_path}
export GOPATH=%{gopathdir}

make build BUILD_PROMU=false

%install
install -d -p %{buildroot}%{_bindir}
export PROM_BUILDDIR="%{_builddir}/%{repo}-%{commit}"
install -D -p -m 0755 ${PROM_BUILDDIR}/prometheus %{buildroot}%{_bindir}/prometheus
install -D -p -m 0755 ${PROM_BUILDDIR}/promtool %{buildroot}%{_bindir}/promtool
install -d %{buildroot}%{_sysconfdir}/prometheus
install -D -p -m 0644 ${PROM_BUILDDIR}/documentation/examples/prometheus.yml %{buildroot}%{_sysconfdir}/prometheus/prometheus.yml
install -d %{buildroot}%{_datadir}/prometheus/console_libraries
install -D -p -m 0644 ${PROM_BUILDDIR}/console_libraries/* %{buildroot}%{_datadir}/prometheus/console_libraries
install -d %{buildroot}%{_datadir}/prometheus/consoles
install -D -p -m 0644 ${PROM_BUILDDIR}/consoles/* %{buildroot}%{_datadir}/prometheus/consoles

%files -n %{repo}
%license LICENSE NOTICE
%doc CHANGELOG.md CONTRIBUTING.md MAINTAINERS.md README.md
%config %{_sysconfdir}/prometheus/prometheus.yml
%{_bindir}/prometheus
%{_bindir}/promtool
%{_datadir}/prometheus/console_libraries
%{_datadir}/prometheus/consoles

%changelog
* Wed Mar 28 2018 Paul Gier <pgier@redhat.com> - 2.2.1-1
- Upgrade to 2.2.1

* Wed Feb 21 2018 Paul Gier <pgier@redhat.com> - 2.1.0-1
- Upgrade to 2.1.0

* Wed Jan 10 2018 Yaakov Selkowitz <yselkowi@redhat.com> - 2.0.0-2.git0a74f98
- Rebuilt for ppc64le, s390x enablement

* Wed Nov 08 2017 Paul Gier <pgier@redhat.com> - 2.0.0-1
- Upgrade to 2.0.0 ga

* Fri Oct 27 2017 Paul Gier <pgier@redhat.com> - 2.0.0_rc.2-1
- Upgrade to 2.0.0_rc.2

* Tue Oct 03 2017 Paul Gier <pgier@redhat.com> - 2.0.0_beta.5-1
- Upgrade to 2.0.0_beta.5 with openshift patches

* Fri Sep 01 2017 Paul Gier <pgier@redhat.com> - 2.0.0_beta.2-2.gitcb0f605
- Use sources from forked openshift project
- Don't build the duplicate binary package
- Strip debug info

* Wed Aug 23 2017 Paul Gier <pgier@redhat.com> - 2.0.0_beta.2-1.gita52f082
- First package for Openshift
